--
-- Mod: Field Data
--
-- Author: xDeekay
-- email: domkopp29@gmail.com
-- @Date: 07.01.2019
-- @Version: 0.0.0.1 Beta
-- Copyright (C) xDeekay, All Rights Reserved.

fieldData = {};

local modDesc = loadXMLFile("modDesc", g_currentModDirectory .. "modDesc.xml");

fieldData.version = getXMLString(modDesc, "modDesc.version");
fieldData.modDirectory = g_currentModDirectory;

inputsActive = false
showFieldData = false
fruitIndex = 1 -- number of index for fruits above the field (drawing Data)
addModEventListener(fieldData);

function fieldData:loadMap()

print("############################################################");
print("--- Field Data v.:" .. self.version .. ", by xDeekay.");
print("############################################################");

end

function fieldData:keyEvent(unicode, sym, modifier, isDown)

end;

function fieldData:mouseEvent(posX, posY, isDown, isUp, button)
end;

function fieldData:deleteMap()
end;

function fieldData:update(dt)
    
    if g_currentMission:getIsClient() then
        if g_gui.currentGui == nil and g_currentMission.controlledVehicle == nil then

        if not inputsActive then
                local _1, eventShowFieldData = g_currentMission.inputManager:registerActionEvent(InputAction.FIELD_DATA, fieldData, fieldData.ShowFieldData, false, true, false, true); --, false, true, false, true); 
                    if g_inputBinding ~= nil and g_inputBinding.events ~= nil and g_inputBinding.events[eventShowFieldData] ~= nil then 
                        g_inputBinding.events[eventShowFieldData].displayIsVisible = false 
                    end 
                     local _2, eventIncreaseFruitIndex = g_currentMission.inputManager:registerActionEvent(InputAction.FIELD_DATA_INCREASE_INDEX, fieldData, fieldData.IncreaseFruitIndex, false, true, false, true); --, false, true, false, true); 
                    if g_inputBinding ~= nil and g_inputBinding.events ~= nil and g_inputBinding.events[eventIncreaseFruitIndex] ~= nil then 
                        g_inputBinding.events[eventIncreaseFruitIndex].displayIsVisible = false 
                    end 
            else
                inputsActive = false
            end
        end
    end
end

function fieldData:IncreaseFruitIndex()
    if fruitIndex == 15 then -- 16 = unkraut
            fruitIndex = 1
        end
        fruitIndex = fruitIndex + 1
end 

function fieldData:ShowFieldData()
    showFieldData =not showFieldData
end

function fieldData:getPlayerPosition()
     if g_currentMission.player ~= nil then 
      local player_pos_x,player_pos_y,player_pos_z = g_currentMission.player:getPositionData()
        return player_pos_x,player_pos_y,player_pos_z
        else 
            return 0,0,0;
        end
end

function fieldData:draw()
    
    if showFieldData == true then 
    
    setTextBold(false);
    setTextColor(1,1,1,1); 
    setTextAlignment(RenderText.ALIGN_CENTER); 
    linePadding = 0.003;
    fontSize = 0.013;
    paddingBetweenLines = fontSize + 0.004;
    
    local playerIsOwnerOfField = false
    local fieldInfoText = ""
   -- local fieldAreaInHa = 0.0
    local fieldPrice = 0.0
    local distanceFromPlayerToField = 0.0
    local maxDistanceFromPlayerToField = 150.0 -- meters away from player 
    
    local player_pos_x,player_pos_y,player_pos_z = fieldData:getPlayerPosition()
    
    local x1, y1, z1 = getWorldTranslation(getCamera())
    
    if g_fieldManager.fields ~= nil then 
  
    for k,field in pairs(g_fieldManager.fields) do
        
        local farmland = field.farmland
        local field_pos_x = field.posX
        local field_pos_z = field.posZ
        local field_Id = field.fieldId
        local field_hectar = field.fieldArea
        local farmland_hectar = farmland.areaInHa
        local fieldPartitions = 0 
        local field_fruitType = ""
        local field_fruitTypeName = ""
        local fruitSeedNeededForField = 0.0
        
        if farmland.isOwned == true then 
            playerIsOwnerOfField = true
        
            distanceFromPlayerToField = math.sqrt(math.pow((player_pos_x - field_pos_x),2) + math.pow((player_pos_z - field_pos_z),2))
            if distanceFromPlayerToField < maxDistanceFromPlayerToField then

                local x = field_pos_x
                local y = 100 -- meters above the field
                local z = field_pos_z
                local dist1 = x-x1
                local dist2 = y-y1
                local dist3 = z-z1
                local dist = MathUtil.vector3Length(x-x1, y-y1, z-z1)
                   if dist <= 150 then
                        local sx, sy, sz = project(x, y, z)
                        if sz <= 1 then -- shows the text only in one direction
                       
                            fieldPartitions = fieldData:getTableLength(field.getFieldStatusPartitions)
                       
                            local field_fruitType = fruitIndex -- player must press a key to increase the number
                            local field_fruitTypeName = g_fruitTypeManager.indexToFruitType[field_fruitType].fillType.title -- name of Fruit in String
                            local fruitSeedNeededForField = math.ceil(fieldData:calculateSeedQuantityForField(field_hectar, field_fruitType))
                            local field_fruitPrice = fieldData:calculateSeedPriceForField(fruitSeedNeededForField)
                            
                            local moneyUnit = g_i18n.moneyUnit
                            local currency = ""
                                if moneyUnit == 1 then 
                                    currency = "€" elseif moneyUnit == 2 then 
                                        currency = "$" elseif moneyUnit == 3 then 
                                            currency = "£" end
                           
                            setTextBold(false)
                            setTextColor(1, 1, 1, 1) -- white 
                            renderText(sx,sy,fontSize,"Field: " .. field_Id .. " Field ha: ".. tostring(field_hectar) .. " Farmland ha: " .. tostring(farmland_hectar))
                            renderText(sx,sy-paddingBetweenLines,fontSize,"Field partitions: " .. tostring(fieldPartitions))
                            setTextBold(true)
                            setTextColor(0, 1, 0, 1) -- green 
                            renderText(sx,sy-paddingBetweenLines-0.015,fontSize,"ca.: " .. tostring(fruitSeedNeededForField) .. "L " ..tostring(field_fruitTypeName) .. " needed Price: " .. tostring(field_fruitPrice) .. tostring(currency))
                            end
                        end
                    end 
                end
            end
        end
    end 
end
    
    -- this function calculate the seed quantity for the field close to the player
    function fieldData:calculateSeedQuantityForField(fieldHectar, fruitTypeIndex)
        
        local quantity = 0; -- quantity to seed the complete field with the selected fruitType
        local field_m2 = 0.0
        local seedUsagePerSqm = 0.0
        
            if fieldHectar ~= nil and fruitTypeIndex ~= nil then 
                seedUsagePerSqm = g_fruitTypeManager.indexToFruitType[fruitTypeIndex].seedUsagePerSqm
                field_m2 = fieldHectar * 10000 -- in m2
                
                quantity = math.ceil(field_m2 * seedUsagePerSqm)
            end  
            
        return quantity
    end 
    
      -- this function calculate the price per liter for the field close to the player
    function fieldData:calculateSeedPriceForField(seedQuantity)
        
        local seedPrice = 900; -- price in €,$ for seeding bag
        local price = 0 -- for seedQuantity
            if seedQuantity ~= nil then 
                price = math.ceil((1000 /seedPrice) * seedQuantity)
            end  

        return price
    end 
    
function fieldData:getTableLength(T)
  local count = 0
  for _ in pairs(T) do count = count + 1 end
  return count
end

--function fieldData:getVehiclesData()
    
--   --   local vehicleDatabase = {}
--      local vehicleName = ""
--      local vehicleInOperation = false
--      --local posYPadding = y - paddingBetweenLines
--      local vehiclesCounter = {};

--    if g_currentMission.vehicles ~= nil then 
--        for k,vehicle in pairs(g_currentMission.vehicles) do   
--           -- if vehicle:getCurrentHelper() ~= nil then 
--                if vehicle:getIsOnField() == true then
--                    if vehicle:getFullName() ~= nil then
--                        vehicleName = vehicle:getFullName() -- string
--                      --  table.insert(vehiclesCounter, vehicleName)
--                        renderText(x,posYPadding,fontSize,"Vehicle: " ..vehicleName.. " Operating: " .. tostring(vehicleInOperation))        
--                    end
--                end
            
--         --   end 
        
--        end
--    end
--    --return vehicleDatabase
--end
